# Linux Floppy Router

A Linux based router OS that fits inside a single floppy!

## Features

This system comes with:
- BusyBox based DHCP client and server
- Wireguard
- Basic IPtables build
- BusyBox telnetd for remote configuration
- Driver for the Realtek RTL8139C NIC

## Anti-Features

This system does not come with:
- A way to store configuration files, it lives entirely in RAM
- SSH or any kind of authentication on telnet
- Full IPtables feature set
- Anything advanced

## Why?

Just because it's a fun little project!

## How to build

You shold be able to build this project simply by running the `build.sh` script.  
It requires the `nasm` compiler for the bootloader and a working GCC toolchain for the rest.  
On Debian, run `sudo apt install nasm build-essentials` to install the required packages.

## Default configuration

The default configuration is to configure the first NIC as WAN via DHCP and the second NIC as LAN, with a static IP of 192.168.100.1/24 and a DHCP server handing out addresses from 192.168.100.101 to 192.168.100.254. Outbound connections through WAN or the Wireguard interface described below are masqueraded by default, any incoming connections on WAN or the Wireguard interface aside from established and related connections are dropped.  
To configure a Wireguard tunnel, place your tunnel configuration in `initramfs-source/etc/wireguard/wg0.conf` and configure your local tunnel IP in `initramfs-source/init` in the variable `WG_IP`, in CIDR notation (e.g. `172.16.0.1/24`). If you want to route a subnet through the Wireguard tunnel, you can add that subnet in CIDR notation in the same file in the variable `WG_ROUTED_SUBNET`, e.g. `10.10.10.0/24`.

## Notes

Due to size constraints, the `cat` program is a simple shell script making use of the `read` command, in a very janky fashion. It will probably break quite easily, but should be fine for simply reading files.